
/*velicina populacije, mora da bude stepen dvojke*/
#define POPSIZE 128
/*broj elitnih jedinki*/
#define NELITE 16
/*broj igraca u tournament selekciji*/
#define NCOMPET 8
/*pocetna verovatnoca mutacije, moze se povecavati kasnije*/
#define MUTATIONPROB 0.005
/*verovatnoca ukrstanja*/
#define CROSSOVERPROB 0.85
/*beskonacno*/
#define INF 65000
/*minimizacija = 1 / maksimizacija =0*/
#define MINIMIZATION 1
/*maksimalan broj cvorova*/
#define MAXNODES 45
/*maksimalan broj grana*/
#define MAXEDGES (MAXNODES*(MAXNODES-1)/2)
/*makro za slucajne brojeve*/
#define step_next(i) (next[i] = next[i] * 1103515245 + 12345+ \
	(unsigned long) sqrt((double)((threadIdx.x)*(threadIdx.x))));
/*velicina unsigned longa u bitovima*/
#define EDGEMEMSIZE (sizeof(char)*8)
/*broj karaktera koje ostavljamo za bitovski niz grana +2 (+1 zbog zaokruzivanja na gore, +1 zbog term. nule*/
#define EDGEMEMNUM (MAXEDGES/EDGEMEMSIZE+2)
#define KERNELLOOP 50

/**********************************************
KODIRANJE
radimo slucaj sa binarnim kodiranjem:
Imamo niz cvorova i linkova, svakom od njih je 
dodeljen binarni niz, koji opisuje da li
je cvor (link) u rezultujucem podgrafu ili ne. 
Algoritam vrsimo samo kao genetski po kodu
linkova, a posle azuriramo niz bitova koji odg-
ovara cvorovima. 
***********************************************/
/*struktura jedinke (hromozom)*/
typedef struct Chrom             
{
	unsigned char *lbit; /*niz bitova koji odgovaraju odabiru linkova*/
	int fit; /*fitness f-ja*/
}chrom;                           
/*struktura grane*/
typedef struct Link{
	short int from;
	short int to;
	short int weight;
}link;

__host__ void ga(char *path, int randSeed, int numOfGen,int objhard, float grphdens);
__host__ void loadInstance(char *path, int *constMemSize);
__host__ void init(chrom popcurrentTemp[POPSIZE]); 
__device__ void generateRandom(chrom *chr); /*odnosi se na generisanje novog slucajnog hromozoma*/
__global__ void generateRandomPopulation(chrom *popcurrent);
__device__ void ev(chrom *chr);
__global__ void evpopInitial(chrom *popcurrent);
__device__ unsigned short int fitness(unsigned char *lbit, int tid);
__device__ int edgeIndex(int i, int j);
__device__ int dfs(unsigned char *lbit);
__device__ int bfs(unsigned char *lbit, int tid);
__device__ int valid(unsigned char *lbit, int tid);
__device__ int Pvalid(unsigned char *lbit, int P, int tid);
__device__ void selection(int tid, unsigned short int sfit[POPSIZE], unsigned char slbit[POPSIZE][EDGEMEMNUM]);
__device__ void crossover(int tid, unsigned short int sfit[POPSIZE], unsigned char slbit[POPSIZE][EDGEMEMNUM]); 
__device__ void mutation(int tid, unsigned short int sfit[POPSIZE], float cModifiedMutationProb);
__host__ char* strrstr(const char *str, const char *strSearch);
__device__ int k_rand(int i);
__global__ void k_srand(unsigned long int seeds[POPSIZE]);
__device__ inline void swapt(int *a, int *b);
__device__  static void bitonicSort(int tid, unsigned short int sfit[POPSIZE],unsigned char slbit[POPSIZE][EDGEMEMNUM]);
__device__ void replaceEqual(int tid, unsigned short int sfit[POPSIZE],unsigned char slbit[POPSIZE][EDGEMEMNUM]);
__device__ void setBit(int idx,unsigned char *bitArr, int val);
__device__ int getBit(int idx,unsigned char *bitArr);
__global__ void GAallInOneOperator(chrom *popcurrent,float *cModifiedMutation, unsigned short int *cBest);