// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently, but
// are changed infrequently
//

#pragma once

#include "targetver.h"

#include <stdio.h>
#include <tchar.h>

/**********************************************
KODIRANJE
radimo slucaj sa binarnim kodiranjem:
Imamo niz cvorova i linkova, svakom od njih je 
dodeljen binarni niz, koji opisuje da li
je cvor (link) u rezultujucem podgrafu ili ne. 
Algoritam vrsimo samo kao genetski po kodu
linkova, a posle azuriramo niz bitova koji odg-
ovara cvorovima. 
***********************************************/


/*struktura jedinke (hromozom)*/
typedef struct Chrom             
{
	char *lbit; /*niz bitova koji odgovaraju odabiru grana*/
	int *z; /*energije dodeljene svakom od cvorova*/
	double obj; /*f-ja  cilja*/
	double fit; /*f-ja prilagodjenosti*/
	char valid; /* da li je hromozom korektan ('0' ili '1')*/
}chrom;                           

typedef struct Link{
	int from;
	int to;
	int weight;
}link;

typedef struct Problem
{
	int nn, nl; /*broj cvorova i linkova (odnosno grana, posto razm. simetricni slucaj*/
	link *l;
}problem;


void ga(char *path, int randSeed, int num, int objhard, float grphdens);
void loadInstance(char *path);
void init(); 
void ev(int j);
void evpop();
void obj(chrom *chr);
int edgeIndex(int i, int j);
void dfs(chrom *chr, int idx);
int bfs(chrom *chr, int idx);
int valid(chrom *chr);
int Pvalid(chrom *chr, int P);
void order(int desc);
void fillTempPop();
void selection();
void replaceEqual();
void generateRandom(int j); /*odnosi se na generisanje novog slucajnog hromozoma*/
void crossover(int type); /*type: 1->one point; INF->uniform*/
void mutation();
int frozenBit(int idx);
void toggle(int itm, int idx);
void fitness(chrom *chr);
void freeAll();
char* strrstr(const char *str, const char *strSearch);

